      subroutine constant
      include 'para.inc'
      include 'poten.inc'
      include 'set_kind.inc'
c
c  tersoff parameter
cccc parameter Si(C)
c--------------------------------
c      i_mi = 1 ! ( 1: Izumi, 0:Marty)
      if (i_mi.eq.1)write(6,*)'izumi potential' 
c
      a_ss=1830.8d0
      if ( i_mi.eq.0) a_sh= 323.54d0 ! Marty
      if ( i_mi.eq.1) a_sh= 456.00d0 ! Izumi
c
      if ( i_mi.eq.0) a_hh=  80.07d0 ! Marty
      if ( i_mi.eq.1) a_hh=  97.25d0 ! Izumi
c--------------------------------
      b_ss=471.18d0
      if ( i_mi.eq.0) b_sh= 84.18d0 ! Marty
      if ( i_mi.eq.1) b_sh= 70.65917d0 ! Izumi
c
      if ( i_mi.eq.0) b_hh= 31.38d0 ! Marty
      if ( i_mi.eq.1) b_hh= 29.695d0 ! Izumi
c--------------------------------
      amd1_ss=2.4799d0
      if ( i_mi.eq.0) amd1_sh=2.9595d0 ! Marty
      if ( i_mi.eq.1) amd1_sh=0.3393471E+01 ! Izumi
c
      if ( i_mi.eq.0) amd1_hh=4.2075d0 ! Marty
      if ( i_mi.eq.1) amd1_hh=4.7390d0 ! Izumi
c--------------------------------
      amd2_ss=1.7322d0
      if ( i_mi.eq.0) amd2_sh=1.6158d0 ! Marty
      if ( i_mi.eq.1) amd2_sh=0.1606774E+01 ! Izumi
c
      if ( i_mi.eq.0) amd2_hh=1.7956d0 ! Marty
      if ( i_mi.eq.1) amd2_hh=1.8690d0 ! Izumi
c--------------------------------
      req_ss = 2.35d0
      if ( i_mi.eq.0) req_sh = 1.475d0 ! Marty
      if ( i_mi.eq.1) req_sh = 1.4824d0 ! Izumi
c
      if ( i_mi.eq.0) req_hh = 0.74d0 ! Marty
      if ( i_mi.eq.1) req_hh = 0.738d0 ! Izumi
c--------------------------------
cc eta (Murty)
      enu_ss=0.78734d0
      enu_sh=1.00d0
      enu_hh=1.00d0
c--------------------------------
      enu2_ss=0.5d0/enu_ss
c**   enu2_ss=0.635050d0
      enu2_sh=0.80469d0
      enu2_hh=0.80469d0
c--------------------------------
c** Type 2 angular function(Murty)
      gc_ss  = 0.0d0
      if ( i_mi.eq.0) gc_sh1 = 0.0216d0 ! Marty
      if ( i_mi.eq.0) gc_sh2 = 0.70d0 ! Marty
      if ( i_mi.eq.0) gc_hh  = 4.00d0
c
      if ( i_mi.eq.1) gc_sh1 = 0.0246d0 ! Izumi
      if ( i_mi.eq.1) gc_hh  = 1.10d0
      if ( i_mi.eq.1) gc_sh2 = 1.40d0
c--------------------------------
c** Type 2 angular function(Murty)
      gd_ss  = 0.16d0
      if ( i_mi.eq.0) gd_sh1 = 0.27d0 ! Marty
      if ( i_mi.eq.0) gd_sh2 = 1.0d0
      gd_hh  = 0.0d0
      if ( i_mi.eq.1) gd_sh1 = 0.4036994E+00 ! Izumi
      if ( i_mi.eq.1) gd_sh2 = gd_hh
c--------------------------------
      alp_ss  = 5.1975d0
      alp_sh1 = 4.00d0
      if ( i_mi.eq.0) alp_hh = 3.0d0  ! Marty
      if ( i_mi.eq.0) alp_sh2 = alp_hh  ! Marty
      if ( i_mi.eq.1) alp_hh =  2.0d0  ! Izumi
      if ( i_mi.eq.1) alp_sh2 = 2.0d0  ! Izumi
c--------------------------------
      bet_ss  = 3.0d0
      bet_sh1 = 3.0d0
      bet_hh  = 1.0d0
      bet_sh2 = bet_hh
c--------------------------------
      gh_ss  = -0.59826d0  ! Si-Si-Si
      gh_sh2 = -1.0d0      ! H-Si-Si
      gh_hh  =  0.0d0      ! H-H-H
c
      if ( i_mi.eq.0) cutr_ss=2.85d0
      if ( i_mi.eq.0) cutd_ss=0.15d0
      if ( i_mi.eq.1) cutr_ss=3.0d0
      if ( i_mi.eq.1) cutd_ss=0.2d0
c
      if ( i_mi.eq.0) cutr_sh=1.85d0
      if ( i_mi.eq.0) cutd_sh=0.15d0
      if ( i_mi.eq.1) cutr_sh=2.25d0
      if ( i_mi.eq.1) cutd_sh=0.15d0
c
      cutr_hh=1.40d0
      cutd_hh=0.30d0
c--------------------------------
      bcutss = ( cutr_ss + cutd_ss )
      bcutsh = ( cutr_sh + cutd_sh )
      bcuthh = ( cutr_hh + cutd_hh )
c--------------------------------
      a1_ss=a_ss
      a1_sh=a_sh
      a1_hh=a_hh
c--------------------------------
      b2_ss=b_ss/2.0d0
      b2_sh=b_sh/2.0d0
      b2_hh=b_hh/2.0d0
c--------------------------------
cc For Si-C system
c** Type 1 angular function(Tersoff)
c      qd_ss = 16.218d0
c      qc_ss = 1.0039d+05
c      qdd_ss = qd_ss *  qd_ss 
c      qcc_ss = qc_ss *  qc_ss 
c      qcd_ss = 1.0d0 + qcc_ss / qdd_ss 
c      qh_ss = -0.59826d0
c      qa_ss = 1.1000d-06
c----------------------------------------
cccc for 2-body parameters
      damd1(1)=amd1_ss ;damd2(1)=amd2_ss  
      damd1(2)=amd1_sh ;damd2(2)=amd2_sh  
      damd1(3)=amd1_hh ;damd2(3)=amd2_hh  
c
      dreq(1)=req_ss
      dreq(2)=req_sh
      dreq(3)=req_hh
c
      denu(1)=enu_ss ;denu2(1)=enu2_ss 
      denu(2)=enu_sh ;denu2(2)=enu2_sh 
      denu(3)=enu_hh ;denu2(3)=enu2_hh 
c
      dcutr(1)=cutr_ss; dcutd(1)=cutd_ss
      dcutr(2)=cutr_sh; dcutd(2)=cutd_sh
      dcutr(3)=cutr_hh; dcutd(3)=cutd_hh
c
      dbcut(1) = bcutss
      dbcut(2) = bcutsh
      dbcut(3) = bcuthh
c
      da1(1)=a1_ss ;db2(1)=b2_ss
      da1(2)=a1_sh ;db2(2)=b2_sh
      da1(3)=a1_hh ;db2(3)=b2_hh
c
      return
      end

