      subroutine matcal(hmat,smat,hmati,hmatt,hmatti,gmat,gmati,
     &                  sigma,apst0,vol,vgmat,vhmat)
      include 'para.inc'
c for matrix ( constant )
      dimension  smat(3,3),hmat(3,3)
c for matrix ( variable )
      dimension  hmati(3,3),hmatt(3,3),hmatti(3,3),gmat(3,3),gmati(3,3),
     &           sigma(3,3),apst0(3,3)
c for Parinello method
      dimension vgmat(3,3),vhmat(3,3)
c local variable
      dimension apst1(3,3),apst2(3,3)
c
ccc  det(h)
      vol=hmat(1,1)*hmat(2,2)*hmat(3,3)+hmat(1,3)*hmat(2,1)*hmat(3,2)
     &+hmat(3,1)*hmat(1,2)*hmat(2,3)-hmat(3,1)*hmat(2,2)*hmat(1,3)-
     &hmat(1,1)*hmat(3,2)*hmat(2,3)-hmat(1,2)*hmat(2,1)*hmat(3,3)
ccc  h_inverse
      hmati(1,1)=hmat(2,2)*hmat(3,3)-hmat(2,3)*hmat(3,2)
      hmati(1,2)=-hmat(1,2)*hmat(3,3)+hmat(3,2)*hmat(1,3)
      hmati(1,3)=hmat(1,2)*hmat(2,3)-hmat(1,3)*hmat(2,2)  
      hmati(2,1)=-hmat(2,1)*hmat(3,3)+hmat(3,1)*hmat(2,3)
      hmati(2,2)=hmat(1,1)*hmat(3,3)-hmat(1,3)*hmat(3,1)
      hmati(2,3)=-hmat(1,1)*hmat(2,3)+hmat(2,1)*hmat(1,3)
      hmati(3,1)=hmat(2,1)*hmat(3,2)-hmat(2,2)*hmat(3,1)
      hmati(3,2)=-hmat(1,1)*hmat(3,2)+hmat(3,1)*hmat(1,2)
      hmati(3,3)=hmat(1,1)*hmat(2,2)-hmat(2,1)*hmat(1,2)
c
      detinv=1.0d0/vol
c      
      do j=1,3
         do i=1,3
            hmati(i,j)=hmati(i,j)*detinv
            hmatt(i,j)=hmat(j,i) ! hmat-transe
         enddo
      enddo
ccc  gmat h^t h
      do j=1,3
      do i=1,3
       gmat(j,i)=hmatt(j,1)*hmat(1,i)+hmatt(j,2)*hmat(2,i)
     &+hmatt(j,3)*hmat(3,i)
      enddo
      enddo
c
ccc  gmat_inverse
      gmati(1,1)=gmat(2,2)*gmat(3,3)-gmat(2,3)*gmat(3,2)
      gmati(1,2)=-gmat(1,2)*gmat(3,3)+gmat(3,2)*gmat(1,3)
      gmati(1,3)=gmat(1,2)*gmat(2,3)-gmat(1,3)*gmat(2,2)  
      gmati(2,1)=-gmat(2,1)*gmat(3,3)+gmat(3,1)*gmat(2,3)
      gmati(2,2)=gmat(1,1)*gmat(3,3)-gmat(1,3)*gmat(3,1)
      gmati(2,3)=-gmat(1,1)*gmat(2,3)+gmat(2,1)*gmat(1,3)
      gmati(3,1)=gmat(2,1)*gmat(3,2)-gmat(2,2)*gmat(3,1)
      gmati(3,2)=-gmat(1,1)*gmat(3,2)+gmat(3,1)*gmat(1,2)
      gmati(3,3)=gmat(1,1)*gmat(2,2)-gmat(2,1)*gmat(1,2)
c
      detg=gmat(1,1)*gmat(2,2)*gmat(3,3)+gmat(1,3)*gmat(2,1)*gmat(3,2)
     &+gmat(3,1)*gmat(1,2)*gmat(2,3)-gmat(3,1)*gmat(2,2)*gmat(1,3)-
     &gmat(1,1)*gmat(3,2)*gmat(2,3)-gmat(1,2)*gmat(2,1)*gmat(3,3)
c
      detginv=1.0d0/detg
c      
      do j=1,3
         do i=1,3
            gmati(i,j)=gmati(i,j)*detginv
         enddo
      enddo
c
ccc hmat-transe-inverse
c
      hmatti(1,1)=hmatt(2,2)*hmatt(3,3)-hmatt(2,3)*hmatt(3,2)
      hmatti(1,2)=-hmatt(1,2)*hmatt(3,3)+hmatt(3,2)*hmatt(1,3)
      hmatti(1,3)=hmatt(1,2)*hmatt(2,3)-hmatt(1,3)*hmatt(2,2)  
      hmatti(2,1)=-hmatt(2,1)*hmatt(3,3)+hmatt(3,1)*hmatt(2,3)
      hmatti(2,2)=hmatt(1,1)*hmatt(3,3)-hmatt(1,3)*hmatt(3,1)
      hmatti(2,3)=-hmatt(1,1)*hmatt(2,3)+hmatt(2,1)*hmatt(1,3)
      hmatti(3,1)=hmatt(2,1)*hmatt(3,2)-hmatt(2,2)*hmatt(3,1)
      hmatti(3,2)=-hmatt(1,1)*hmatt(3,2)+hmatt(3,1)*hmatt(1,2)
      hmatti(3,3)=hmatt(1,1)*hmatt(2,2)-hmatt(2,1)*hmatt(1,2)
c
      detinv=1.0d0/vol
c      
      do j=1,3
          do i=1,3
             hmatti(i,j)=hmatti(i,j)*detinv
          enddo
      enddo
c
ccc vgmat dG/dt
      do i=1,3
      vgmat(1,i)=vhmat(1,1)*hmat(1,i)+hmat(1,1)*vhmat(1,i)
     &          +vhmat(2,1)*hmat(2,i)+hmat(2,1)*vhmat(2,i)
     &          +vhmat(3,1)*hmat(3,i)+hmat(3,1)*vhmat(3,i)
      vgmat(2,i)=vhmat(1,2)*hmat(1,i)+hmat(1,2)*vhmat(1,i)
     &          +vhmat(2,2)*hmat(2,i)+hmat(2,2)*vhmat(2,i)
     &          +vhmat(3,2)*hmat(3,i)+hmat(3,2)*vhmat(3,i)
      vgmat(3,i)=vhmat(1,3)*hmat(1,i)+hmat(1,3)*vhmat(1,i)
     &          +vhmat(2,3)*hmat(2,i)+hmat(2,3)*vhmat(2,i)
     &          +vhmat(3,3)*hmat(3,i)+hmat(3,3)*vhmat(3,i)
      enddo
c
      do j=1,3
         do i=1,3
            sigma(i,j)=vol*hmatti(i,j) ! A = V h^{-t}
            apst1(i,j)=vol*smat(i,j) ! V \sigma
         enddo
      enddo
c
cccc Vh^{-1}\sigma
      do j=1,3
      do i=1,3
         apst2(j,i)=hmati(j,1)*apst1(1,i)+hmati(j,2)*apst1(2,i)
     &+hmati(j,3)*apst1(3,i)
      enddo
      enddo
c
cccc \Sigma = V h^{-1} \sigma h^{-t}
      do j=1,3
      do i=1,3
        apst0(j,i)=apst2(j,1)*hmatti(1,i)+apst2(j,2)*hmatti(2,i)
     &+apst2(j,3)*hmatti(3,i)
      enddo
      enddo
c
ccccc check ???
c      write(88,*)'hmatt='
c      do 101 i=1,3
c         write(88,*)hmatt(i,1),hmatt(i,2),hmatt(i,3)
c 101  continue
c      write(88,*)'hmati='
c      do 102 i=1,3
c         write(88,*)hmati(i,1),hmati(i,2),hmati(i,3)
c 102  continue
c      write(88,*)'gmat='
c      do 103 i=1,3
c         write(88,*)gmat(i,1),gmat(i,2),gmat(i,3)
c 103  continue
c      write(88,*)'gmati='
c      do 104 i=1,3
c         write(88,*)gmati(i,1),gmati(i,2),gmati(i,3)
c 104  continue
c      write(88,*)'vgmat='
c      do 105 i=1,3
c         write(88,*)vgmat(i,1),vgmat(i,2),vgmat(i,3)
c 105  continue
ccccccccccccccc
c
      return
      end
