      subroutine balance
     &(iall,istr,iend,vx,vy,vz,vxi,vyi,vzi,hmat)
      include 'para.inc'
      dimension vx(iall),vy(iall),vz(iall)
      dimension vxi(iall),vyi(iall),vzi(iall)
      dimension hmat(3,3)
c
      vxx=0.0d0
      vyy=0.0d0
      vzz=0.0d0
c     
      do i=istr,iend
         vxx=vxx+vxi(i)
         vyy=vyy+vyi(i)
         vzz=vzz+vzi(i)
      enddo
c
c      if (iend.eq.istr) stop 'error in balance.f'
      rim = 1.0d0/float(iend-istr+1)
      vxx2=vxx*rim
      vyy2=vyy*rim
      vzz2=vzz*rim
c
      do i=istr,iend
         vxi(i)=vxi(i)-vxx2
         vyi(i)=vyi(i)-vyy2
         vzi(i)=vzi(i)-vzz2
      enddo
c
c******  adjust the center of gravity
c      xa=0.0d0
c      ya=0.0d0
c      za=0.0d0
cc
c      do i=istr,iend
c       xa=xa+xi(i)
c       ya=ya+yi(i)
c       za=za+zi(i)
c      enddo
cc
cc
c      xjj=0.5d0
c      yjj=0.5d0
c      zjj=0.5d0
cc
c      xb=xa*rim-xjj
c      yb=ya*rim-yjj
c      zb=za*rim-zjj
c
c      do i=istr,iend
c        xi(i)=xi(i)-xb
c        yi(i)=yi(i)-yb
c        zi(i)=zi(i)-zb
c      enddo
c
      do i=istr,iend
         vx(i)=hmat(1,1)*vxi(i)+hmat(1,2)*vyi(i)+hmat(1,3)*vzi(i)
         vy(i)=hmat(2,1)*vxi(i)+hmat(2,2)*vyi(i)+hmat(2,3)*vzi(i)
         vz(i)=hmat(3,1)*vxi(i)+hmat(3,2)*vyi(i)+hmat(3,3)*vzi(i)
      enddo
c
      return
      end



