      subroutine book_period
     &(idel,istr_b,iend_b,iall,ndivxn,ndivyn,ndivzn,ndivx,ndivy,ndivz,
     &nkind,nc,nbr,npbx,npby,npbz,nbrall,nbrp,nbrmax,iddm,nbstep,nstep,
     &x,y,z,xi,yi,zi,vx,vy,vz,gmat,hmat,
     &rtest,rxi,ryi,rzi,rbook,cutdeg,dt,bc_si,dmarg1,dmarg2,bcut_r)
c
      include 'para.inc'
      include 'set_kind.inc'
c     image coordinate
      dimension x(iall),y(iall),z(iall)
      dimension xi(iall),yi(iall),zi(iall)
      dimension vx(iall),vy(iall),vz(iall)
      dimension gmat(3,3),hmat(3,3)
c neighbors' information
      dimension nbrall(nbinfo,iall*ncut),nbrp(ncut,iall)
      dimension nbr(ncut,iall),nc(iall)
c neighbors boundary condition
      dimension npbx(ncut,iall),npby(ncut,iall),npbz(ncut,iall)
c     kind of atom ( 1:Si , 2:H , 3:C )
      dimension nkind(iall)      
ccc   local variables ( prbook )
c    ndiv*    for domain decomposition
      dimension ndivx(iall),ndivy(iall),ndivz(iall)
c     ndiv*n   # of division for *-direction
c       ndivxn,ndivyn,ndivzn
ccc   local variables   iall? or *?
      dimension rr(iall*ncut)
      dimension rtest(iall*ncut)
      dimension rx0(iall),rx1(iall),rx2(iall),
     &          sx0(iall),sx1(iall),sx2(iall),
     &          ry0(iall),ry1(iall),ry2(iall),
     &          sy0(iall),sy1(iall),sy2(iall),
     &          rz0(iall),rz1(iall),rz2(iall),
     &          sz0(iall),sz1(iall),sz2(iall)
      dimension rxi(iall),ryi(iall),rzi(iall),rbook(iall)
C----- these are for array for vectorization
ccc kakunou yo
      dimension IDDM(iall)
c
      ifrag=0
c******initialize data 
      if (idel.eq.0) then
      nc=0
      nbrmax=0
      endif
c*****
c   xi,yi,zi image coordinates
c    so  ( 0 < xi,yi,zi < 1 )
cnkmr---add
      call prbook_p(iall,ndivx,ndivy,ndivz,ndivxn,ndivyn,ndivzn,
     &x,y,z,xi,yi,zi,hmat,cutdeg,bcut_r)
c
c      do 20 i=1,iall-1
      do 20 i=istr_b,iend_b   ! Modified 01-11-01
c
         LNKMR=0
c         IDDM=0
c
         do 34 j=i+1,iall
ccccc use pre-condition for book-keeping 
            ndivxx =  abs(ndivx(j)-ndivx(i))
            if(ndivxx.gt.1.and.ndivxx.lt.ndivxn-1)go to 34
            ndivyy =  abs(ndivy(j)-ndivy(i))
            if(ndivyy.gt.1.and.ndivyy.lt.ndivyn-1)go to 34
            ndivzz =  abs(ndivz(j)-ndivz(i))
            if(ndivzz.gt.1.and.ndivzz.lt.ndivzn-1)go to 34
ccccc free surface (z-direction)
c            if(ndivzz.gt.1)go to 34
c            if(ndivzz.gt.ndcut)go to 34
            LNKMR=LNKMR+1
            IDDM(LNKMR)=J
   34    continue
c
         do 30 jnn=1,LNKMR
            j=IDDM(jnn)
c
            rx0(j)=xi(j)-xi(i)
            rx1(j)=xi(j)-xi(i)+1.0d0
            rx2(j)=xi(j)-xi(i)-1.0d0
c
c  sx0,sx1,sx2 : periodic boundary parameter
c
       sx0(j)=(dsign(1.0d0,0.5d0-abs(rx0(j)))+1)*0.5d0
       sx1(j)=(dsign(1.0d0,0.5d0-abs(rx1(j)))+1)*0.5d0
       sx2(j)=(dsign(1.0d0,0.5d0-abs(rx2(j)))+1)*0.5d0
c
            ry0(j)=yi(j)-yi(i)
            ry1(j)=yi(j)-yi(i)+1.0d0
            ry2(j)=yi(j)-yi(i)-1.0d0
c
c  sy0,sy1,sy2 : periodic boundary parameter
c
        sy0(j)=(dsign(1.0d0,0.5d0-dabs(ry0(j)))+1)*0.5d0
        sy1(j)=(dsign(1.0d0,0.5d0-dabs(ry1(j)))+1)*0.5d0
        sy2(j)=(dsign(1.0d0,0.5d0-dabs(ry2(j)))+1)*0.5d0
c
            rz0(j)=zi(j)-zi(i)
            rz1(j)=zi(j)-zi(i)+1.0d0
            rz2(j)=zi(j)-zi(i)-1.0d0
c
c  sz0,sz1,sz2 : periodic boundary parameter
c
       sz0(j)=(dsign(1.0d0,0.5d0-dabs(rz0(j)))+1)*0.5d0
       sz1(j)=(dsign(1.0d0,0.5d0-dabs(rz1(j)))+1)*0.5d0
       sz2(j)=(dsign(1.0d0,0.5d0-dabs(rz2(j)))+1)*0.5d0
C-------------------------------------
c
         if (((sx0(j)+sx1(j)+sx2(j)).gt.1).or.
     &       ((sx0(j)+sx1(j)+sx2(j)).lt.bug)) then
c          write(99,*)'error book1x',i,j,rx0,rx1,rx2,nstep
               sx0(j)=1.0d0
               sx1(j)=0.0d0
               sx2(j)=0.0d0
             endif
c
         if (((sy0(j)+sy1(j)+sy2(j)).gt.1).or.
     &       ((sy0(j)+sy1(j)+sy2(j)).lt.bug)) then
c           write(99,*)'error book1y',i,j,rx0,rx1,rx2,nstep
               sy0(j)=1.0d0
               sy1(j)=0.0d0
               sy2(j)=0.0d0
             endif
c
         if (((sz0(j)+sz1(j)+sz2(j)).gt.1).or.
     &       ((sz0(j)+sz1(j)+sz2(j)).lt.bug)) then
c          write(99,*)'error book1z',i,j,rx0,rx1,rx2,nstep
               sz0(j)=1
               sz1(j)=0
               sz2(j)=0
             endif
c
c  xi(j)-xi(i)
       rxi(j)=sx0(j)*rx0(j)+sx1(j)*rx1(j)+sx2(j)*rx2(j)  
c  yi(j)-yi(i)
       ryi(j)=sy0(j)*ry0(j)+sy1(j)*ry1(j)+sy2(j)*ry2(j)  
c  zi(j)-zi(i)
       rzi(j)=sz0(j)*rz0(j)+sz1(j)*rz1(j)+sz2(j)*rz2(j)  
ccccc free surface (z-direction)
c        rzi(j)=rz0(j)
c
c****** transfer real space
        rbook(j)=gmat(1,1)*rxi(j)*rxi(j)+gmat(2,1)*ryi(j)*rxi(j)
     &                             +gmat(3,1)*rzi(j)*rxi(j)+
     &      gmat(1,2)*rxi(j)*ryi(j)+gmat(2,2)*ryi(j)*ryi(j)
     &                             +gmat(3,2)*rzi(j)*ryi(j)+
     &      gmat(1,3)*rxi(j)*rzi(j)+gmat(2,3)*ryi(j)*rzi(j)
     &                             +gmat(3,3)*rzi(j)*rzi(j)
c
 30   continue
c
      nci=nc(i)
c
        do 32 jnn=1,LNKMR
          j=IDDM(jnn)
c****** cut off 
c
          nk1 = nkind(i)
          nk2 = nkind(j)
c
      kbnd = npairbond(nk1,nk2)
c
      bcut = dbcut(kbnd)
cccccccc velocity dependent book-keeping
       vvxi=vx(i); vvxj=vx(j); vvyi=vy(i); vvyj=vy(j)
       vvzi=vz(i); vvzj=vz(j)
c
       vij_av = sqrt((vvxi-vvxj)*(vvxi-vvxj) +
     &   (vvyi-vvyj)*(vvyi-vvyj) + (vvzi-vvzj)*(vvzi-vvzj))
c
       vij_av2 = hmat(1,1)*rxi(j)*(vvxj-vvxi) +
     &   hmat(2,2)*ryi(j)*(vvyj-vvyi) + hmat(3,3)*rzi(j)*(vvzj-vvzi)
c
       srd=sqrt(rbook(j))
       vij_av2 = vij_av2/srd
c
       if (vij_av2 .lt. 0.0d0) then  ! if inner
          dis_ij2 = dabs(vij_av2) * nbstep * dt * dmarg1
c          dis_ij2 = bcut * dmarg2
       else
          dis_ij2 = bcut * dmarg2
       endif ! if inner
c
          bcut = bcut + dis_ij2
c
       bcut2 = bcut * bcut
c
       if ((rbook(j) .lt. bcut2) .and. (rbook(j) .gt. 0.0d0 )) then
c          
       srd=sqrt(rbook(j))
c
c****** Warning Message ************************************
       if (bcut.gt.bcut_r*cutdeg) then
       write(99,*)'book-keeping WARNING(bcut.gt.bcut_r*cutdeg)! '
     &,nstep
c***      write(98,*)'time step or book-keeping interval must be small,'
c***          write(98,*)'or the size of the sub-region must be enlarged'
c***          write(6,*)'book-keeping warning2(bcut.gt.bcutss*cutdeg)! 
c***     &     time step or book-keeping interval must be small'
c***          write(6,*)'distance',dis_ij,' else',dis_ij2
c***      write(98,*)'step=',nstep
c***      write(98,*)'atom',i,'(',nkind(i),')-atom',j,'(',nkind(j),')'
c***      write(98,*)'velocity',vij_av2,' else',vij_av
c***      write(98,*)'distance',dis_ij2,' else',dis_ij
c***      write(98,*)'nbstep',nbstep
c     write(98,*)'nbstep,wi,wj',nbstep,wi,wj
c***      write(98,*)'bcut,(rbook(j))**0.5',bcut,srd
c***      write(98,*)(('-'),iii=1,20)
c     stop
      endif
c****** Warning Message ************************************
c
c     nc(i): number of particles around atom i
          ncj=nc(j)
c
          nci=nci+1
          ncj=ncj+1

ccccc The nci-th neighborhood  of atom i is atom j
ccccc The ncj-th neighborhood  of atom j is atom i
          nbr(nci,i)=j
          nbr(ncj,j)=i
c------------- set nbrall(*,*)-- add
C
C  if   i=nbrall(1,np),j=nbrall(2,np),nn=nbrall(3,np), then
C   nn-th bond is (i,j)pair.
C
C     nbrmax:  No. of (i,j) pairs
C------------------
C  npr=nbrp(jj,i) shows bond number(npr) for jj-th adiacent atom
C  for i-th atom. This array is used with nbr(*,*).
C
          nbrmax=nbrmax+1
          nbrall(1,nbrmax)=i
          nbrall(2,nbrmax)=j
          nbrall(3,nbrmax)=nci
          nbrall(4,nbrmax)=ncj
          nbrall(5,nbrmax)=kbnd
          rtest(nbrmax)=sqrt(rbook(j))
          rr(nbrmax)=bcut
ccccc The nci-th bond of atom i is nbrp(nci,i)
ccccc The ncj-th bond of atom j is nbrp(ncj,j)
          nbrp(nci,i)=nbrmax
          nbrp(ncj,j)=nbrmax
c
          npbx(nci,i)=(1-sx0(j))*(sx1(j)-sx2(j))
          npby(nci,i)=(1-sy0(j))*(sy1(j)-sy2(j))
          npbz(nci,i)=(1-sz0(j))*(sz1(j)-sz2(j))
          npbx(ncj,j)=-npbx(nci,i)
          npby(ncj,j)=-npby(nci,i)
          npbz(ncj,j)=-npbz(nci,i)
c
        nc(j)=ncj
        endif
 32     continue
        nc(i)=nci
c
      if ((nci.gt.ncut).or. (ncj.gt.ncut)) then
      write(99,*)'book-keeping error nc(i).gt.ncut :i,nc(i)',i,nc(i)
      ifrag=1
c     stop 'book-keeping error : nc(i).gt.ncut'
      endif
c
 20       continue
c
c    output  data
      IF(ICODE.NE.1)THEN
      open(2,file='nc_book.dat')
      do 100 i=1,iall
         jj=nc(i)
c        
         if (jj.eq.0) go to 201
         do 200 j=1,jj
            npr=nbrp(j,i)
       write(2,'(1x,7i5,2e15.7)')
     & npr,i,nbr(j,i),npbx(j,i),npby(j,i),npbz(j,i),jj,rtest(npr),
     & rr(npr)
 200  continue
 201  continue
 100  continue
      endfile(2)
      close(2)
      ENDIF

      if (ifrag.eq.1) stop 'book-keeping error : nc(i).gt.ncut'
c
      return
      end
c
c
c pre-condition for book-keeping
      subroutine prbook_p(iall,ndivx,ndivy,ndivz,ndivxn,ndivyn,ndivzn,
     &x,y,z,xi,yi,zi,hmat,cutdeg,bcut_r)
      include 'para.inc'
ccc   original
ccc   ndiv*    for domain decomposition
      dimension ndivx(iall),ndivy(iall),ndivz(iall)
ccc   image coordinate
      dimension x(iall),y(iall),z(iall)
      dimension xi(iall),yi(iall),zi(iall)
      dimension hmat(3,3)
C-------------------------------------------------------
C   Input :  point coordinates
C   Output:  tile number that points are located
C-------------------------------------------------------
c 
c   xi,yi,zi image coordinates
c    so  ( 0 < xi,yi,zi < 1 )
c
cccc  adjusted for silicon 
      cut_ri = 1.0d0/bcut_r/cutdeg
      ndivxn=int(hmat(1,1)*cut_ri)
      ndivyn=int(hmat(2,2)*cut_ri)
      ndivzn=int(hmat(3,3)*cut_ri)
c      ndivzn=int((ztop-zbtm)*cut_ri)
      xdx=1.0d0/float(ndivxn)
      ydy=1.0d0/float(ndivyn)
      zdz=1.0d0/float(ndivzn)
c     zdz=(ztop-zbtm)/float(ndivzn)
c
      do i=1,iall
cxxxx       
           nnx= mod(int(xi(i)/xdx),ndivxn)+ 1
           if( xi(i) .lt. 0.0d0 ) nnx=1
           if( xi(i) .gt. 1.0d0 ) nnx=ndivxn
           ndivx(i)  = nnx         
cyyyy 
           nny= mod(int(yi(i)/ydy),ndivyn) + 1
           if( yi(i) .lt. 0.0d0 ) nny=1
           if( yi(i) .gt. 1.0d0 ) nny=ndivyn
           ndivy(i)  = nny
czzzz
           nnz= mod(int(zi(i)/zdz),ndivzn) + 1
           if( zi(i) .lt. 0.0d0 ) nnz=1
           if( zi(i) .gt. 1.0d0 ) nnz=ndivzn
           ndivz(i)  = nnz
c
c           nnz= mod(int((z(i)-zbtm)/zdz),ndivzn) + 1
c           if( z(i) .lt. zbtm ) nnz=1
c           if( z(i) .gt. ztop ) nnz=ndivzn
c           ndivz(i)  = nnz
      enddo
c     
      return
      end
c
