      subroutine input(iall,nstat,nkind,iatm,
     &x,y,z,vx,vy,vz,xi,yi,zi,vxi,vyi,vzi,fx,fy,fz,ddx2,ddy2,ddz2,
     &wg,wginv,hmat,hmat0,hmati,vol,hmat0i,vol0)
      include 'para.inc'
      include 'set_kind.inc'   ! modified at 2001-10-16
c
      dimension x(iall),y(iall),z(iall) ! atomic coordinates
      dimension vx(iall),vy(iall),vz(iall) ! atomic velocity
      dimension xi(iall),yi(iall),zi(iall) ! atomic coordinates
      dimension vxi(iall),vyi(iall),vzi(iall) ! atomic velocity
      dimension fx(iall),fy(iall),fz(iall) ! atomic force
      dimension ddx2(iall),ddy2(iall),ddz2(iall)
      dimension nkind(iall)
      dimension hmat(3,3),hmat0(3,3),hmati(3,3),hmat0i(3,3)
      dimension wg(iall),wginv(iall)
      dimension iatm(iregion)
c      
ccc read x,y,z,vx,vy,vz,fx,fy,fz
      read(9,*)iiii; read(9,*)
c      nsi    =0;  ncarb  =0;  nhydr  =0
      write(6,*)'reading initial coordinates & velocity.....'
      do i=1,iall
         read(9,'(i2,6e21.13)')nkk,x(i),y(i),z(i),vx(i),vy(i),vz(i)
         nkind(i) = kind_atm(nkk)     ! modified at 2001-10-16
         wg(i) = wg_kind(nkind(i))    ! modified at 2001-10-16
         wginv(i) = 1.0d0/wg(i)         ! modified at 2001-10-16
c
      enddo
c
      close(9)
c
c****read hmat(i,j)
      write(6,*)'reading initial lattice.....'
      do i=1,3
      read(11,'(3e21.13)')hmat(i,1),hmat(i,2),hmat(i,3)
      enddo
      if (hmat(1,1).eq.0.0d0) hmat(1,1)=1D+03
      if (hmat(2,2).eq.0.0d0) hmat(2,2)=1D+03
      if (hmat(3,3).eq.0.0d0) hmat(3,3)=1D+03
c
      do i=1,3
           read(11,'(3e21.13)')hmat0(i,1),hmat0(i,2),hmat0(i,3)
      enddo
      close(11)
c
c*****  not initialized ( sleep now )
       if (nstat.eq.1) then
       write(6,*)'*********************************'
       write(6,*)'*     READ FROM pforce.dat      *'
       write(6,*)'*********************************'
      do i=1,iall
         read(10,'(3e21.13)')fx(i),fy(i),fz(i)
      enddo
      do i=1,iall
          read(10,'(3e21.13)')ddx2(i),ddy2(i),ddz2(i)
      enddo
      endif
      close(10)
cccccccccccccccccccccc
      vol=hmat(1,1)*hmat(2,2)*hmat(3,3)+hmat(1,3)*hmat(2,1)*hmat(3,2)
     &+hmat(3,1)*hmat(1,2)*hmat(2,3)-hmat(3,1)*hmat(2,2)*hmat(1,3)-
     &hmat(1,1)*hmat(3,2)*hmat(2,3)-hmat(1,2)*hmat(2,1)*hmat(3,3)
ccc  h_inverse
      hmati(1,1)=hmat(2,2)*hmat(3,3)-hmat(2,3)*hmat(3,2)
      hmati(1,2)=-hmat(1,2)*hmat(3,3)+hmat(3,2)*hmat(1,3)
      hmati(1,3)=hmat(1,2)*hmat(2,3)-hmat(1,3)*hmat(2,2)  
      hmati(2,1)=-hmat(2,1)*hmat(3,3)+hmat(3,1)*hmat(2,3)
      hmati(2,2)=hmat(1,1)*hmat(3,3)-hmat(1,3)*hmat(3,1)
      hmati(2,3)=-hmat(1,1)*hmat(2,3)+hmat(2,1)*hmat(1,3)
      hmati(3,1)=hmat(2,1)*hmat(3,2)-hmat(2,2)*hmat(3,1)
      hmati(3,2)=-hmat(1,1)*hmat(3,2)+hmat(3,1)*hmat(1,2)
      hmati(3,3)=hmat(1,1)*hmat(2,2)-hmat(2,1)*hmat(1,2)
c
      detinv=1.0d0/vol
c      
      do  j=1,3
         do i=1,3
            hmati(i,j)=hmati(i,j)*detinv
         enddo
      enddo
c
cccccccccccccccccccccc
c
      vol0=hmat0(1,1)*hmat0(2,2)*hmat0(3,3)
     &+hmat0(1,3)*hmat0(2,1)*hmat0(3,2)
     &+hmat0(3,1)*hmat0(1,2)*hmat0(2,3)
     &-hmat0(3,1)*hmat0(2,2)*hmat0(1,3)
     &-hmat0(1,1)*hmat0(3,2)*hmat0(2,3)
     &-hmat0(1,2)*hmat0(2,1)*hmat0(3,3)
ccc  h_inverse
      hmat0i(1,1)=hmat0(2,2)*hmat0(3,3)-hmat0(2,3)*hmat0(3,2)
      hmat0i(1,2)=-hmat0(1,2)*hmat0(3,3)+hmat0(3,2)*hmat0(1,3)
      hmat0i(1,3)=hmat0(1,2)*hmat0(2,3)-hmat0(1,3)*hmat0(2,2)  
      hmat0i(2,1)=-hmat0(2,1)*hmat0(3,3)+hmat0(3,1)*hmat0(2,3)
      hmat0i(2,2)=hmat0(1,1)*hmat0(3,3)-hmat0(1,3)*hmat0(3,1)
      hmat0i(2,3)=-hmat0(1,1)*hmat0(2,3)+hmat0(2,1)*hmat0(1,3)
      hmat0i(3,1)=hmat0(2,1)*hmat0(3,2)-hmat0(2,2)*hmat0(3,1)
      hmat0i(3,2)=-hmat0(1,1)*hmat0(3,2)+hmat0(3,1)*hmat0(1,2)
      hmat0i(3,3)=hmat0(1,1)*hmat0(2,2)-hmat0(2,1)*hmat0(1,2)
c
      detinv0=1.0d0/vol0
c      
      do j=1,3
       do  i=1,3
            hmat0i(i,j)=hmat0i(i,j)*detinv0
      enddo
      enddo
c**** set image vector xi,vxi...
      if (nstat.eq.2) then
c
      do i=iatm(1)+1,iall
         xi(i)=hmat0i(1,1)*x(i)+hmat0i(1,2)*y(i)+hmat0i(1,3)*z(i)
         yi(i)=hmat0i(2,1)*x(i)+hmat0i(2,2)*y(i)+hmat0i(2,3)*z(i)
         zi(i)=hmat0i(3,1)*x(i)+hmat0i(3,2)*y(i)+hmat0i(3,3)*z(i)
         vxi(i)=hmat0i(1,1)*vx(i)+hmat0i(1,2)*vy(i)+hmat0i(1,3)*vz(i)
         vyi(i)=hmat0i(2,1)*vx(i)+hmat0i(2,2)*vy(i)+hmat0i(2,3)*vz(i)
         vzi(i)=hmat0i(3,1)*vx(i)+hmat0i(3,2)*vy(i)+hmat0i(3,3)*vz(i)
c
         x(i)=hmat(1,1)*xi(i)+hmat(1,2)*yi(i)+hmat(1,3)*zi(i)
         y(i)=hmat(2,1)*xi(i)+hmat(2,2)*yi(i)+hmat(2,3)*zi(i)
         z(i)=hmat(3,1)*xi(i)+hmat(3,2)*yi(i)+hmat(3,3)*zi(i)
         vx(i)=hmat(1,1)*vxi(i)+hmat(1,2)*vyi(i)+hmat(1,3)*vzi(i)
         vy(i)=hmat(2,1)*vxi(i)+hmat(2,2)*vyi(i)+hmat(2,3)*vzi(i)
         vz(i)=hmat(3,1)*vxi(i)+hmat(3,2)*vyi(i)+hmat(3,3)*vzi(i)
      enddo
c
      else
c
      do i=1,iall
         xi(i)=hmat0i(1,1)*x(i)+hmat0i(1,2)*y(i)+hmat0i(1,3)*z(i)
         yi(i)=hmat0i(2,1)*x(i)+hmat0i(2,2)*y(i)+hmat0i(2,3)*z(i)
         zi(i)=hmat0i(3,1)*x(i)+hmat0i(3,2)*y(i)+hmat0i(3,3)*z(i)
         vxi(i)=hmat0i(1,1)*vx(i)+hmat0i(1,2)*vy(i)+hmat0i(1,3)*vz(i)
         vyi(i)=hmat0i(2,1)*vx(i)+hmat0i(2,2)*vy(i)+hmat0i(2,3)*vz(i)
         vzi(i)=hmat0i(3,1)*vx(i)+hmat0i(3,2)*vy(i)+hmat0i(3,3)*vz(i)
c
         x(i)=hmat(1,1)*xi(i)+hmat(1,2)*yi(i)+hmat(1,3)*zi(i)
         y(i)=hmat(2,1)*xi(i)+hmat(2,2)*yi(i)+hmat(2,3)*zi(i)
         z(i)=hmat(3,1)*xi(i)+hmat(3,2)*yi(i)+hmat(3,3)*zi(i)
         vx(i)=hmat(1,1)*vxi(i)+hmat(1,2)*vyi(i)+hmat(1,3)*vzi(i)
         vy(i)=hmat(2,1)*vxi(i)+hmat(2,2)*vyi(i)+hmat(2,3)*vzi(i)
         vz(i)=hmat(3,1)*vxi(i)+hmat(3,2)*vyi(i)+hmat(3,3)*vzi(i)
      enddo
c
      endif
c
      return
      end


