      subroutine verlet_mlt(ifstr,iall,istr,iend,
cccc for tersoff_h.f (same as verlet.f)
     &     nkind,nc,nbr,npbx,npby,npbz,nbrall,nbrp,nbrmax,
cccc for verlet_mlt.f (same as verlet.f)
     &     dt,ddx2,ddy2,ddz2,hmat,hmati,fx,fy,fz,dx,dy,dz,
     &     x,y,z,xi,yi,zi,vx,vy,vz,vxi,vyi,vzi,stress,vij,wginv,wg,
cccc for multistep
     &     nkind_m,nc_m,nbr_m,npbx_m,npby_m,npbz_m,nbrall_m,nbrp_m,
     &     nbrmax_m,mltf,imltf,imltf2,rtest_m,mltfn,mltn,
     &     ddx2_m,ddy2_m,ddz2_m,x_m,y_m,z_m,vx_m,vy_m,vz_m,
     &     xi_m,yi_m,zi_m,vxi_m,vyi_m,vzi_m,fx_m,fy_m,fz_m,
     &     dx_m,dy_m,dz_m,wginv_m)
      include 'para.inc'
c neighbors' information
      dimension nbrall(nbinfo,iall*ncut),nbrp(ncut,iall)
      dimension nbr(ncut,iall),nc(iall)
c neighbors boundary condition
      dimension npbx(ncut,iall),npby(ncut,iall),npbz(ncut,iall) 
c kind of atom ( 1:Si , 2:H , 3:C )
      dimension nkind(iall)
c
      dimension ddx2(iall),ddy2(iall),ddz2(iall) 
      dimension hmat(3,3),hmati(3,3),stress(6,iall)
c atomic potential energy
      dimension vij(iall)
c atomic coordinates
      dimension x(iall),y(iall),z(iall)
c atomic velocity
      dimension vx(iall),vy(iall),vz(iall)
c image coordinate
      dimension xi(iall),yi(iall),zi(iall)
c image velocity
      dimension vxi(iall),vyi(iall),vzi(iall)
c atomic force
      dimension fx(iall),fy(iall),fz(iall)
c for tersoff_h.f
      dimension dx(iall),dy(iall),dz(iall)
ccc atomic weight
      dimension wginv(iall),wg(iall)
c for multi-step     
      dimension mltf(iall),imltf(iall),imltf2(iall)
cccc  for multistep
      dimension nkind_m(iall/nmlt)
      dimension nbr_m(ncut,iall/nmlt),nc_m(iall/nmlt)
      dimension npbx_m(ncut,iall/nmlt),npby_m(ncut,iall/nmlt)
     &                                    ,npbz_m(ncut,iall/nmlt)
      dimension nbrall_m(nbinfo,iall/nmlt*ncut),nbrp_m(ncut,iall/nmlt)
c
      dimension ddx2_m(iall/nmlt),ddy2_m(iall/nmlt),ddz2_m(iall/nmlt)
      dimension x_m(iall/nmlt),y_m(iall/nmlt),z_m(iall/nmlt)
      dimension vx_m(iall/nmlt),vy_m(iall/nmlt),vz_m(iall/nmlt)
      dimension xi_m(iall/nmlt),yi_m(iall/nmlt),zi_m(iall/nmlt)
      dimension vxi_m(iall/nmlt),vyi_m(iall/nmlt),vzi_m(iall/nmlt)
      dimension fx_m(iall/nmlt),fy_m(iall/nmlt),fz_m(iall/nmlt)
      dimension dx_m(iall/nmlt),dy_m(iall/nmlt),dz_m(iall/nmlt)
      dimension wginv_m(iall/nmlt)
      dimension rtest_m(iall/nmlt*ncut)
c
c-------------------------------------------------------------------
c     verlet integration for all atoms ----outer loop
c      istr = 1;  iend = icls + isub 
c     
      dt2=dt/2.0d0
c     
c  atomic coordination ( avoiding the lost of keta)
      do 140 i=istr,iend
         dnch = float(1 - imltf2(i))
         dx(i)=vxi(i)+dt2*ddx2(i)*dnch
         dy(i)=vyi(i)+dt2*ddy2(i)*dnch
         dz(i)=vzi(i)+dt2*ddz2(i)*dnch
         vxi(i)=dx(i)
         vyi(i)=dy(i)
         vzi(i)=dz(i)
 140   continue
c
       do 170 i=istr,iend
         vx(i)=hmat(1,1)*vxi(i)+hmat(1,2)*vyi(i)+hmat(1,3)*vzi(i)
         vy(i)=hmat(2,1)*vxi(i)+hmat(2,2)*vyi(i)+hmat(2,3)*vzi(i)
         vz(i)=hmat(3,1)*vxi(i)+hmat(3,2)*vyi(i)+hmat(3,3)*vzi(i)
 170  continue
c
      iall_m = mltfn
      do 750 knew = 1, iall_m
ccc new number --> old number
         kold = mltf(knew)
c         if (kold.lt.knew) stop 'kd.lt.kk!'
         xi_m(knew)=xi(kold)
         yi_m(knew)=yi(kold)
         zi_m(knew)=zi(kold)
         vxi_m(knew)=vxi(kold)
         vyi_m(knew)=vyi(kold)
         vzi_m(knew)=vzi(kold)
         ddx2_m(knew)=ddx2(kold)
         ddy2_m(knew)=ddy2(kold)
         ddz2_m(knew)=ddz2(kold)
         nkind_m(knew)=nkind(kold)
         wginv_m(knew)=wginv(kold)
 750  continue
c
      dtm  = dt/float(mltstep)
      dtm2 = dtm/2.0d0
c verlet integration for H atoms ----inner loop
      do 777 kkk = 1,mltstep
c
      do 150 i = istr,iend
         dnch = float(1 - imltf2(i))
         xi(i) = xi(i) + dx(i)*dtm*dnch
         yi(i) = yi(i) + dy(i)*dtm*dnch
         zi(i) = zi(i) + dz(i)*dtm*dnch
 150  continue
c
cccc atomic coordination
      do 145 i=1,mltn
         dx_m(i)=vxi_m(i)+dtm2*ddx2_m(i)
         dy_m(i)=vyi_m(i)+dtm2*ddy2_m(i)
         dz_m(i)=vzi_m(i)+dtm2*ddz2_m(i)
 145  continue
c
      do i = 1,mltn
         xi_m(i)=xi_m(i)+dx_m(i)*dtm
         yi_m(i)=yi_m(i)+dy_m(i)*dtm
         zi_m(i)=zi_m(i)+dz_m(i)*dtm
      enddo
c
      do i = mltn+1,mltfn
         ml1 = mltf(i)
         xi_m(i)=xi(ml1)
         yi_m(i)=yi(ml1)
         zi_m(i)=zi(ml1)
      enddo
c
c  partial velocity
      do 165 i=1,mltn
        vxi_m(i)=dx_m(i)
        vyi_m(i)=dy_m(i)
        vzi_m(i)=dz_m(i)
 165  continue
c
       do 175 i=1,iall_m  ! need iall_m atoms   
       x_m(i)=hmat(1,1)*xi_m(i)+hmat(1,2)*yi_m(i)+hmat(1,3)*zi_m(i)
       y_m(i)=hmat(2,1)*xi_m(i)+hmat(2,2)*yi_m(i)+hmat(2,3)*zi_m(i)
       z_m(i)=hmat(3,1)*xi_m(i)+hmat(3,2)*yi_m(i)+hmat(3,3)*zi_m(i)
 175  continue
c
       ifstr_m = 1
       istr_m = 1 
c
       call calc_force(ifstr_m,iall_m,istr_m,iall_m,nkind_m,
     &    nc_m,nbr_m,npbx_m,npby_m,npbz_m,nbrall_m,nbrp_m,nbrmax_m,
     &    x_m,y_m,z_m,fx_m,fy_m,fz_m,hmat,stress,vij)
c
      do 185 i=1,mltn
       wg_i = wginv_m(i)
      ddx2_m(i)=(hmati(1,1)*fx_m(i)+hmati(1,2)*fy_m(i)+
     &                                 hmati(1,3)*fz_m(i))*wg_i
      ddy2_m(i)=(hmati(2,1)*fx_m(i)+hmati(2,2)*fy_m(i)+
     &                                 hmati(2,3)*fz_m(i))*wg_i
      ddz2_m(i)=(hmati(3,1)*fx_m(i)+hmati(3,2)*fy_m(i)+
     &                                 hmati(3,3)*fz_m(i))*wg_i
 185  continue
c
c  velocity
      do 190 i=1,mltn
        vxi_m(i)=vxi_m(i)+dtm2*ddx2_m(i)
        vyi_m(i)=vyi_m(i)+dtm2*ddy2_m(i)
        vzi_m(i)=vzi_m(i)+dtm2*ddz2_m(i)
 190  continue
c
c
 777  continue
c
c verlet integration for H atoms ----inner loop
c
      do 200 i=1,iall_m
       x_m(i)=hmat(1,1)*xi_m(i)+hmat(1,2)*yi_m(i)+hmat(1,3)*zi_m(i)
       y_m(i)=hmat(2,1)*xi_m(i)+hmat(2,2)*yi_m(i)+hmat(2,3)*zi_m(i)
       z_m(i)=hmat(3,1)*xi_m(i)+hmat(3,2)*yi_m(i)+hmat(3,3)*zi_m(i)
       vx_m(i)=
     & hmat(1,1)*vxi_m(i)+hmat(1,2)*vyi_m(i)+hmat(1,3)*vzi_m(i)
       vy_m(i)=
     & hmat(2,1)*vxi_m(i)+hmat(2,2)*vyi_m(i)+hmat(2,3)*vzi_m(i)
       vz_m(i)=
     & hmat(3,1)*vxi_m(i)+hmat(3,2)*vyi_m(i)+hmat(3,3)*vzi_m(i)
 200  continue
c     
       do 285 i=istr,iend
         x(i)=hmat(1,1)*xi(i)+hmat(1,2)*yi(i)+hmat(1,3)*zi(i)
         y(i)=hmat(2,1)*xi(i)+hmat(2,2)*yi(i)+hmat(2,3)*zi(i)
         z(i)=hmat(3,1)*xi(i)+hmat(3,2)*yi(i)+hmat(3,3)*zi(i)
 285  continue
c
      do 500 i = 1,mltn
         inew = mltf(i)
         xi(inew) = xi_m(i)
         yi(inew) = yi_m(i)
         zi(inew) = zi_m(i)
         vxi(inew) = vxi_m(i)
         vyi(inew) = vyi_m(i)
         vzi(inew) = vzi_m(i)
         x(inew) = x_m(i)
         y(inew) = y_m(i)
         z(inew) = z_m(i)
         vx(inew) = vx_m(i)
         vy(inew) = vy_m(i)
         vz(inew) = vz_m(i)
         fx(inew) = fx_m(i)
         fy(inew) = fy_m(i)
         fz(inew) = fz_m(i)
         ddx2(inew) = ddx2_m(i)
         ddy2(inew) = ddy2_m(i)
         ddz2(inew) = ddz2_m(i)
 500  continue
c
ccc verlet integration method (for all atoms)      
c     
      call calc_force(ifstr,iall,istr,iend,
     &        nkind,nc,nbr,npbx,npby,npbz,nbrall,nbrp,nbrmax,
     &        x,y,z,fx,fy,fz,hmat,stress,vij)
c
      if (ifstr.eq.0) 
     &call press(iall,istr,iend,nkind,vx,vy,vz,stress,hmat,wg)
c
      do 270 i=istr,iend
       wg_i = wginv(i)
      ddx2(i)=
     & (hmati(1,1)*fx(i)+hmati(1,2)*fy(i)+hmati(1,3)*fz(i))*wg_i
      ddy2(i)=
     & (hmati(2,1)*fx(i)+hmati(2,2)*fy(i)+hmati(2,3)*fz(i))*wg_i
      ddz2(i)=
     & (hmati(3,1)*fx(i)+hmati(3,2)*fy(i)+hmati(3,3)*fz(i))*wg_i
 270  continue
c
c  velocity
      do 280 i=istr,iend
        dnch = float(1 - imltf2(i))
        vxi(i)=vxi(i)+dt2*ddx2(i)*dnch
        vyi(i)=vyi(i)+dt2*ddy2(i)*dnch
        vzi(i)=vzi(i)+dt2*ddz2(i)*dnch
 280   continue
c
       do 290 i=istr,iend
         vx(i)=hmat(1,1)*vxi(i)+hmat(1,2)*vyi(i)+hmat(1,3)*vzi(i)
         vy(i)=hmat(2,1)*vxi(i)+hmat(2,2)*vyi(i)+hmat(2,3)*vzi(i)
         vz(i)=hmat(3,1)*vxi(i)+hmat(3,2)*vyi(i)+hmat(3,3)*vzi(i)
 290  continue
c
      return
      end

